"use strict";
var cache, get, ref, set, writeCache;
ref = require('./data'), cache = ref.cache, writeCache = ref.writeCache;
if (cache.verCache == null) {
  cache.verCache = {};
}
get = function(name, expire) {
  var info, interval;
  if (expire == null) {
    expire = 1000;
  }
  info = cache.verCache[name];
  if (info) {
    interval = info.expire || expire;
    if (Date.now() - info.t < interval) {
      if (typeof info.version === 'string') {
        return null;
      } else {
        return info.version;
      }
    } else {
      delete cache.verCache[name];
      return null;
    }
  } else {
    return null;
  }
};
set = function(name, verObj) {
  return cache.verCache[name] = {
    version: verObj,
    t: Date.now()
  };
};
module.exports = {
  get: get,
  set: set,
  record: writeCache
};
