"use strict";
var cmder, opts;
cmder = require('commander');
cmder.usage("[command] [options]").version(require('./util').curVer);
cmder.command('clean').description('clean cache').action(function() {
  var writeCacheSync;
  writeCacheSync = require('./data').writeCacheSync;
  writeCacheSync({});
  return process.exit(0);
});
cmder.command('dump').description('dump cache').action(function() {
  var cache, cachePath, chalk, ref, util;
  chalk = require('chalk');
  util = require('util');
  ref = require('./data'), cache = ref.cache, cachePath = ref.cachePath;
  console.log(chalk.bold(chalk.yellow('Cache path:'), chalk.magenta(cachePath)));
  console.log(util.inspect(cache.verCache || {}, {
    colors: true
  }));
  return process.exit(0);
});
cmder.option('-g, --global', "Check global packages").option('-A, --All', "Check all projects in sub directories, depth is 1").option('-w, --writeBack', "Write updated version back to package.json").option('-i, --install', "Install the latest version of the packages").option('-l, --lock', "Use specific versions in package.json, with no ranges. (except *)").option('--lock-all', "Lock, even for * version").option('-a, --all', "Shortcut for -wil").option('-m, --mirror <mirror host or name>', "Use a mirror registry host").option('--no-cache', "Disable version cache").option('--no-warning', "Disable warning").option('-d, --dep', "Check dependencies only").option('-D, --dev', "Check devDependencies only").option('-O, --optional', "Check optionalDependencies only").option('-c, --cwd <cwd>', "Set current working directory").option('-L, --logLevel <level>', "Set loglevel for npm, default is error").option('-t, --tag <tag>', "Dist-tag used as the version to be updated").option('-e, --exclude <list>', "Excluded packages list, split by comma or space", function(list) {
  return list.split(/,|\s/);
}).option('-o, --only <list>', "Included packages list, split by comma or space", function(list) {
  return list.split(/,|\s/);
}).option('-p --exclude-locked', "Exclude all locked packages");
cmder.parse(process.argv);
opts = (function(cmder) {
  var depNames, res;
  opts = cmder;
  opts.lock = cmder.lock || cmder.lockAll;
  cmder.exclude && (opts.exclude = cmder.exclude);
  cmder.only && (opts.include = cmder.only);
  depNames = ['dep', 'dev', 'optional'];
  res = depNames.reduce(function(res, cur) {
    return res = res || cmder[cur];
  }, false);
  if (res) {
    depNames.forEach(function(name) {
      return opts[name] = !!cmder[name];
    });
  } else {
    depNames.forEach(function(name) {
      return opts[name] = !cmder[name];
    });
  }
  return opts;
})(cmder);
require('./npm-up')(opts, true)["catch"](function(e) {
  if (e) {
    console.error(e.stack || e);
  }
  return process.exit(1);
});
