"use strict";
var cache, cachePath, fs, homedir, os, path, writeCache, writeCacheSync;
fs = require('nofs');
path = require('path');
os = require('os');
homedir = (function() {
  if (typeof os.homedir === 'function') {
    return os.homedir();
  } else {
    return process.env[process.platform === 'win32' ? 'USERPROFILE' : 'HOME'];
  }
})();
cachePath = path.join(homedir, '.npmupcache');
cache = (function() {
  var e;
  try {
    return fs.readJSONSync(cachePath);
  } catch (error) {
    e = error;
    return {};
  }
})();
if (cache.lastTime && Date.now() - cache.lastTime > 20 * 60 * 1000) {
  cache.verCache = {};
}
cache.lastTime = Date.now();
writeCache = function(c) {
  if (c == null) {
    c = cache;
  }
  return fs.outputJSON(cachePath, c, {
    space: 2
  })["catch"](console.error);
};
writeCacheSync = function(c) {
  var e;
  if (c == null) {
    c = cache;
  }
  try {
    return fs.outputJSONSync(cachePath, c, {
      space: 2
    });
  } catch (error) {
    e = error;
    return console.error(e);
  }
};
module.exports = {
  cache: cache,
  writeCache: writeCache,
  writeCacheSync: writeCacheSync,
  cachePath: cachePath
};
