"use strict";
var Promise, chalk, npm, semver, util;
npm = require('./npm');
util = require('./util');
chalk = require('chalk');
Promise = require('nofs').Promise;
semver = require('semver');
module.exports = function(packages, cwd) {
  var cmd, promise;
  if (cwd == null) {
    cwd = null;
  }
  if (!packages.length) {
    return Promise.resolve();
  }
  util.logInfo("Start to install...");
  console.log(chalk.cyan(packages.join(', ') + chalk.green(" will be updated")));
  promise = null;
  cmd = npm.commands.i;
  if (semver.gte(npm.version, '7.0.0')) {
    if (cwd) {
      npm.config.set('prefix', cwd);
    }
    promise = util.promisify(cmd.exec.bind(cmd))(packages);
  } else {
    promise = (cwd ? util.promisify(cmd)(cwd, packages) : util.promisify(cmd)(packages));
  }
  return promise.then(function() {
    return util.logSucc(chalk.green("Latest packages have been installed!"));
  });
};
