"use strict";
var Promise, debug, getRegistry, isNPMRegistry, ref, request, url;
request = require('kiss-request');
Promise = require('nofs').Promise;
ref = require('./util'), debug = ref.debug, isNPMRegistry = ref.isNPMRegistry, getRegistry = ref.getRegistry;
url = require('url');
request.Promise = Promise;
module.exports = function(name, mirror) {
  var link;
  link = url.resolve(mirror, "/-/package/" + (encodeURIComponent(name)) + "/dist-tags");
  debug('[Request Link]', link);
  return request(link).then(function(data) {
    debug('[Version Data]', name + ":", data);
    return JSON.parse(data) || null;
  })["catch"](function(e) {
    if (e.code === 'TIMEOUT') {
      debug('[TIMEOUT]', name);
      return Promise.reject(new Error("Request to " + mirror + " timeout. Try to use an alternative registry by -m <mirror>"));
    } else if (e.code === 'UNWANTED_STATUS_CODE') {
      if (e.statusCode === 404 && !isNPMRegistry(mirror)) {
        debug('[FALLBACK NPM]', name);
        return module.exports(name, getRegistry('npm'));
      } else {
        debug('[UNWANTED_STATUS_CODE]', name, e, '; link: ', link);
        return Promise.resolve(null);
      }
    } else {
      debug('[ERROR]', name, e);
      return Promise.resolve(null);
    }
  });
};
