"use strict";
var Module, cache, path, readPackageFileCwd;
Module = require('module');
path = require('path');
cache = {};
readPackageFileCwd = function(baseDir) {
  var e, err;
  if (baseDir == null) {
    baseDir = '.';
  }
  try {
    return require(path.join(baseDir, 'package.json'));
  } catch (error) {
    e = error;
    if (e instanceof SyntaxError) {
      throw e;
    } else {
      err = new Error("cannot find package.json at " + baseDir + " ");
      err.code = 'ENOENT';
      throw err;
    }
  }
};
module.exports.readPackageFile = function(name, baseDir) {
  var res;
  if (name == null) {
    name = '';
  }
  if (baseDir == null) {
    baseDir = '.';
  }
  baseDir = path.resolve(baseDir);
  if (res = cache[name + baseDir]) {
    return res;
  }
  return cache[name + baseDir] = (function() {
    var dir, e, i, len, moduleDirs, pack;
    if (!name) {
      return readPackageFileCwd(baseDir);
    }
    moduleDirs = Module._nodeModulePaths(baseDir);
    pack = null;
    for (i = 0, len = moduleDirs.length; i < len; i++) {
      dir = moduleDirs[i];
      try {
        return require(path.join(dir, name, 'package.json'));
      } catch (error) {}
    }
    e = new Error('cannot find package.json for module ' + name);
    e.code = 'ENOENT';
    throw e;
  })();
};
module.exports.getPackageVersion = function(name, baseDir) {
  var e;
  try {
    return module.exports.readPackageFile(name, baseDir).version;
  } catch (error) {
    e = error;
    return null;
  }
};
