"use strict";
var bumpMsg, chalk, semver, upgradeMsg, verRe;
semver = require('semver');
chalk = require('chalk');
verRe = /^[><=\s~^]*([\d\w.-\s]*)$/;
upgradeMsg = function(dep, plainDeclareVer) {
  return ((chalk.yellow('updgrade')) + " " + (chalk.cyan(dep.packageName)) + ":") + (" " + (chalk.red(dep.installedVer)) + "(installed) --> " + (chalk.green(plainDeclareVer)) + "(declared)");
};
bumpMsg = function(dep, plainDeclareVer) {
  return ((chalk.yellow('bump')) + " " + (chalk.cyan(dep.packageName)) + ":") + (" " + (chalk.red(plainDeclareVer)) + "(declared) --> " + (chalk.green(dep.installedVer)) + "(installed)");
};
module.exports = {
  version: function(dep) {
    var declareVer, m;
    declareVer = dep.declareVer;
    if (declareVer === '*') {
      if (!dep.installedVer) {
        dep.needUpdate = false;
        dep.baseVer = declareVer;
      } else {
        dep.needUpdate = semver.lt(dep.installedVer, dep.newVer);
      }
      return dep;
    } else if (m = declareVer.match(verRe)) {
      declareVer = m[1];
      if (semver.valid(declareVer)) {
        if (!dep.installedVer) {
          dep.needUpdate = semver.lt(declareVer, dep.newVer);
          dep.baseVer = declareVer;
        } else {
          dep.needUpdate = semver.lt(dep.installedVer, dep.newVer);
          if (semver.lt(dep.installedVer, declareVer)) {
            dep.warnMsg = upgradeMsg(dep, declareVer);
          } else if (semver.gt(dep.installedVer, declareVer)) {
            dep.warnMsg = bumpMsg(dep, declareVer);
          }
        }
        return dep;
      }
    }
    if (!dep.installedVer) {
      dep.needUpdate = semver.gtr(dep.newVer, declareVer);
      dep.baseVer = declareVer;
    } else {
      dep.needUpdate = semver.lt(dep.installedVer, dep.newVer);
      if (semver.ltr(dep.installedVer, declareVer)) {
        dep.warnMsg = upgradeMsg(dep, declareVer);
      } else if (semver.gtr(dep.installedVer, declareVer)) {
        dep.warnMsg = bumpMsg(dep, declareVer);
      }
    }
    return dep;
  }
};
