"use strict";
var chalk, checkVer, interval, semver, util;
chalk = require('chalk');
semver = require('semver');
util = require('./util');
checkVer = require('./checkVersion');
interval = 12 * 3600 * 1000;
module.exports = function(mirror) {
  var promise;
  promise = checkVer(['npm-up'], true, mirror, interval).then(function(arg) {
    var installed, latest;
    latest = arg[0];
    installed = util.curVer + '';
    if (semver.lt(installed, latest)) {
      return chalk.yellow.bold("\n>> New npm-up available:", chalk.green(latest), chalk.grey("(current: " + installed + ")"));
    } else {
      return "";
    }
  })["catch"](function() {});
  promise.log = function() {
    return promise.then(function(msg) {
      return msg && console.log(msg);
    });
  };
  return promise;
};
